## 简介

gtc(generate test case) 是一个把http请求转换为测试代码的cli工具

## 功能

- [x] 支持解析curl命令
- [x] 支持解析postman文件
- [x] 支持解析swagger2文件
- [x] 支持生成笛卡尔积测试脚本
- [x] 支持解析curl文件并生成Jmeter性能脚本
- [x] 支持解析curl文件并生成Locust性能脚本
- [ ] 支持解析postman文件并生成Jmeter性能脚本
- [ ] 一键生成Jmeter性能压测方案脚本

## 安装

```bash
pip3 install gentccode
gtc version
```

## 使用

1. 执行下面命令,会在当前目录生成api文件(`api.yaml`)和测试代码的脚本文件(`test_case.py`)

```bash
gtc curl curl.txt
gtc postman postman.json
gtc swagger2 swagger.json
```

2. 根据参数生成笛卡尔积的用例脚本

```bash
gtc cp -n a. curl.txt
```

3. 执行下面命令,会生成对应的压测脚本

```bash
gtc jmeter curl.txt --json-assert code=0
gtc locust curl.txt
```

## 已知问题

- 若postman文件中有变量,则不会生成相对应的代码块.
- url中必须有http或https协议头
